spool 1-Cr_Tablas.log
prompt creando tablas...
-- Borro todas las tablas
DROP TABLE PCIUNOVOT_ANYO; 
DROP TABLE VOTMASPART_ANYO; 
DROP TABLE VOTMASP_LOCANY; 
DROP TABLE HIS_VOTMASPARTI; 
DROP TABLE HIS_VMASDIFOPC; 
DROP TABLE HIS_VMENDIFOPC; 
DROP TABLE HIS_VOTTOPPER; 
DROP TABLE VOTFIN_PAISANYO; 
DROP TABLE VMEDPART_CENSANYO; 
DROP TABLE LOGS;

DROP TABLE PERSOCENSO;
DROP TABLE VOTACENSO;
DROP TABLE LOCALIDAD;
DROP TABLE REGION;
DROP TABLE PAISES;
DROP TABLE VOTAPERSONA; 
DROP TABLE OPCIONES; 
DROP TABLE VOTACION;  
DROP TABLE PERSONAS; 
 

CREATE TABLE PAISES
( CODPAIS      VARCHAR2(02),
  TPAIS        VARCHAR2(30) NOT NULL,
  FBAJA          DATE
);
ALTER TABLE PAISES
  ADD CONSTRAINT PAISES_PK PRIMARY KEY (CODPAIS);

CREATE TABLE REGION
(
  CODPAIS        VARCHAR2(02),
  IDREGION       NUMBER(08),
  TREGION        VARCHAR2(50) NOT NULL,
  FBAJA          DATE
);        
ALTER TABLE REGION
  ADD CONSTRAINT REGION_PK PRIMARY KEY (CODPAIS, IDREGION);

ALTER TABLE REGION
  ADD CONSTRAINT REGION_UK UNIQUE (IDREGION);
  
ALTER TABLE REGION
  ADD CONSTRAINT REGION_PAISES_FK foreign key (CODPAIS)
  REFERENCES PAISES (CODPAIS);    

CREATE TABLE LOCALIDAD
(
  CODPAIS        VARCHAR2(02),
  IDREGION       NUMBER(08),
  IDLOCALI       NUMBER(08),
  TLOCALI        VARCHAR2(50) NOT NULL,
  FBAJA          DATE
);        
ALTER TABLE LOCALIDAD
  ADD CONSTRAINT LOCALIDAD_PK PRIMARY KEY (CODPAIS, IDREGION, IDLOCALI);

ALTER TABLE LOCALIDAD
  ADD CONSTRAINT LOCALIDAD_UK UNIQUE (IDLOCALI);
  
ALTER TABLE LOCALIDAD
  ADD CONSTRAINT LOCALI_REGION_FK foreign key (CODPAIS,IDREGION)
  REFERENCES REGION (CODPAIS,IDREGION); 

CREATE TABLE VOTACION
(
  IDVOTA         NUMBER(08),
  TTITULO        VARCHAR2(20) NOT NULL,
  TDESCRIP       VARCHAR2(50) NOT NULL,
  TNOMPRESI      VARCHAR2(50) NOT NULL,
  FFECINI        DATE         NOT NULL,
  FFECFIN        DATE,
  FFECPUB        DATE         NOT NULL, 
  TWEB           VARCHAR2(30),
  CESTADO        NUMBER(2) NOT NULL,
  NCAPVOT        NUMBER(8),
  NVOTTOT        NUMBER(8),
  PPARTI         NUMBER(5,2)
);

ALTER TABLE VOTACION
  ADD CONSTRAINT VOTACION_PK PRIMARY KEY (IDVOTA);
 
CREATE TABLE VOTACENSO
(
   IDVOTACENSO NUMBER(8),
   IDVOTA     NUMBER(8) NOT NULL,
   CODPAIS    VARCHAR(2),
   IDREGION    NUMBER(8),
   IDLOCALI   NUMBER(8)
);
ALTER TABLE VOTACENSO
  ADD CONSTRAINT VOTACENSO_PK PRIMARY KEY (IDVOTACENSO);

ALTER TABLE VOTACENSO
  ADD CONSTRAINT VOTACENSO_UK UNIQUE (IDVOTA,CODPAIS,IDREGION,IDLOCALI);

ALTER TABLE VOTACENSO
  ADD CONSTRAINT VOTACEN_VOTAC_FK foreign key (IDVOTA)
  REFERENCES VOTACION (IDVOTA);
  
ALTER TABLE VOTACENSO
  ADD CONSTRAINT VOTACEN_LOCALI_FK foreign key (CODPAIS,IDREGION,IDLOCALI)
  REFERENCES LOCALIDAD (CODPAIS,IDREGION,IDLOCALI); 

ALTER TABLE VOTACENSO
  ADD CONSTRAINT VOTACEN_REGION_FK foreign key (CODPAIS,IDREGION)
  REFERENCES REGION (CODPAIS,IDREGION);

ALTER TABLE VOTACENSO ADD CONSTRAINT VOTACEN_PAISES_FK foreign key (CODPAIS)
  REFERENCES PAISES (CODPAIS);

CREATE TABLE OPCIONES
(
   IDVOTA        NUMBER(8),
   NOPCIO        NUMBER(8),
   TOPCION       VARCHAR2(50) NOT NULL,
   NNUMVOT       NUMBER(8),
   PRESTOT       NUMBER(5,2)
);
ALTER TABLE OPCIONES
  ADD CONSTRAINT OPCIONES_PK PRIMARY KEY (IDVOTA, NOPCIO);
  
ALTER TABLE OPCIONES
  ADD CONSTRAINT OPCION_VOTAC_FK foreign key (IDVOTA)
  REFERENCES VOTACION (IDVOTA); 

CREATE TABLE PERSONAS
(
  IDPERSON         NUMBER(08),
  FNACIMI          DATE         NOT NULL,
  CSEXPER          NUMBER(01)   NOT NULL,
  FBAJA            DATE,
  NUMVOTOS         NUMBER(08)        
);  

ALTER TABLE PERSONAS
  ADD CONSTRAINT PERSONAS_PK PRIMARY KEY (IDPERSON);

CREATE TABLE PERSOCENSO
(
  IDPERSON         NUMBER(08),
  FALTA            DATE,
  FBAJA            DATE, 
  CODPAIS          VARCHAR2(02) NOT NULL,  
  IDREGION         NUMBER(08)   NOT NULL,
  IDLOCALI         NUMBER(08)   NOT NULL
);
ALTER TABLE PERSOCENSO
  ADD CONSTRAINT PERSOCENSO_PK PRIMARY KEY (IDPERSON, FALTA);

ALTER TABLE PERSOCENSO
  ADD CONSTRAINT PERSOCENSO_UK UNIQUE (IDPERSON,CODPAIS,IDREGION,IDLOCALI,FALTA);

ALTER TABLE PERSOCENSO
  ADD CONSTRAINT PERSOCEN_PERSO_FK foreign key (IDPERSON)
  REFERENCES PERSONAS (IDPERSON); 
  
ALTER TABLE PERSOCENSO
  ADD CONSTRAINT PERSOCEN_LOCALI_FK foreign key (CODPAIS,IDREGION,IDLOCALI)
  REFERENCES LOCALIDAD (CODPAIS,IDREGION,IDLOCALI); 

CREATE TABLE VOTAPERSONA
(
  IDVOTA        NUMBER(8),
  IDPERSON      NUMBER(8),
  NOPCIO        NUMBER(8)   NOT NULL,
  FVOTA         DATE        NOT NULL,
  NEDADVOTA     NUMBER(3)   NOT NULL
);
ALTER TABLE VOTAPERSONA
  ADD CONSTRAINT VOTAPERSONA_PK PRIMARY KEY (IDVOTA, IDPERSON);

      
ALTER TABLE VOTAPERSONA
  ADD CONSTRAINT VOTAPER_PERSON_FK foreign key (IDPERSON)
      REFERENCES PERSONAS (IDPERSON); 
  
ALTER TABLE VOTAPERSONA
  ADD CONSTRAINT VOTAPER_OPCION_FK foreign key (IDVOTA,NOPCIO)  
      REFERENCES OPCIONES (IDVOTA,NOPCIO);

CREATE TABLE LOGS (
	IDLOGS        NUMBER(08),
	FALTA         DATE NOT NULL,
	FUNCION       VARCHAR2(100) NOT NULL,
	PARIN         VARCHAR2(1000) NOT NULL,
	PAROUT        VARCHAR2(1000) NOT NULL
);
ALTER TABLE LOGS
  ADD CONSTRAINT PK_LOGS PRIMARY KEY (IDLOGS);

-----------------------------------
-- ESTADISTICA
----------------------------------- 1

CREATE TABLE VOTFIN_PAISANYO
(
  CODPAIS      VARCHAR2(02),
  NANYO        NUMBER(04),
  NVOTAFIN     NUMBER(08) NOT NULL
);
ALTER TABLE VOTFIN_PAISANYO
  ADD CONSTRAINT VOTFIN_PK PRIMARY KEY (CODPAIS, NANYO);
  
ALTER TABLE VOTFIN_PAISANYO
ADD CONSTRAINT VOTFIN_PAISES_FK foreign key (CODPAIS)  
      REFERENCES PAISES (CODPAIS);
      
----------------------------------- 2 y 3

CREATE TABLE VMEDPART_CENSANYO
(
  IDVMEDPAR    NUMBER(8),
  TIPCENSO     NUMBER(1),
  CODPAIS      VARCHAR2(02),
  IDREGION     NUMBER(08),
  IDLOCALI     NUMBER(08),
  NANYO        NUMBER(04),
  NVOTAFIN     NUMBER(08),
  PSUMPARTI    NUMBER(5,2),
  NMEDPPAR     NUMBER(05,2)
);
ALTER TABLE VMEDPART_CENSANYO
  ADD CONSTRAINT VMEDPAR_PK PRIMARY KEY (IDVMEDPAR);

ALTER TABLE VMEDPART_CENSANYO
  ADD CONSTRAINT VMEDPAR_UK UNIQUE (NANYO,CODPAIS,IDREGION,IDLOCALI);

ALTER TABLE VMEDPART_CENSANYO
  ADD CONSTRAINT VMEDPAR_LOCALI_FK foreign key (CODPAIS,IDREGION,IDLOCALI)
  REFERENCES LOCALIDAD (CODPAIS,IDREGION,IDLOCALI); 

ALTER TABLE VMEDPART_CENSANYO
  ADD CONSTRAINT VMEDPAR_REGION_FK foreign key (CODPAIS,IDREGION)
  REFERENCES REGION (CODPAIS,IDREGION);

ALTER TABLE VMEDPART_CENSANYO ADD CONSTRAINT VMEDPAR_PAISES_FK foreign key (CODPAIS)
  REFERENCES PAISES (CODPAIS);

----------------------------------- 4
CREATE TABLE VOTMASPART_ANYO
(
  NANYO        NUMBER(04),
  IDVOTA       NUMBER(08),
  NVOTAPAR     NUMBER(08),
  PPARTI       NUMBER(5,2)
);
ALTER TABLE VOTMASPART_ANYO
  ADD CONSTRAINT VMASPART_PK PRIMARY KEY (NANYO, IDVOTA);
  
ALTER TABLE VOTMASPART_ANYO
ADD CONSTRAINT VMASPART_VOTAC_FK foreign key (IDVOTA)  
      REFERENCES VOTACION (IDVOTA);
----------------------------------- 5
CREATE TABLE VOTMASP_LOCANY
(
  NANYO        NUMBER(04),
  CODPAIS      VARCHAR2(02),
  IDREGION     NUMBER(08),
  IDLOCALI     NUMBER(08),
  IDVOTA       NUMBER(08),
  NVOTMPAR     NUMBER(08)
);
ALTER TABLE VOTMASP_LOCANY
  ADD CONSTRAINT VOTMASP_PK PRIMARY KEY (NANYO, CODPAIS, IDREGION, IDLOCALI, IDVOTA);

ALTER TABLE VOTMASP_LOCANY
ADD CONSTRAINT VOTMASP_LOCALI_FK foreign key (CODPAIS, IDREGION, IDLOCALI)  
      REFERENCES LOCALIDAD (CODPAIS, IDREGION, IDLOCALI);
  
ALTER TABLE VOTMASP_LOCANY
ADD CONSTRAINT VOTMASP_VOTACI_FK foreign key (IDVOTA)  
      REFERENCES VOTACION (IDVOTA);
----------------------------------- 6
CREATE TABLE PCIUNOVOT_ANYO
(
  NANYO        NUMBER(04),
  NTOTPER      NUMBER(08),
  NTOTNVOT     NUMBER(08),
  PPERNVOT     NUMBER(5,2)
);
ALTER TABLE PCIUNOVOT_ANYO
  ADD CONSTRAINT PCIUNOVOT_PK PRIMARY KEY (NANYO);

----------------------------------- 7
CREATE TABLE HIS_VOTMASPARTI
(
  IDVOTA       NUMBER(08),
  NTOTPAR      NUMBER(08),
  PPARTI       NUMBER(5,2)
);
ALTER TABLE HIS_VOTMASPARTI
  ADD CONSTRAINT HIS_VOTMAS_PK PRIMARY KEY (IDVOTA);
ALTER TABLE HIS_VOTMASPARTI
  ADD CONSTRAINT HIS_VOTMAS_VOTAC_FK foreign key (IDVOTA)
      REFERENCES VOTACION (IDVOTA);

----------------------------------- 8
CREATE TABLE HIS_VMASDIFOPC
(
  IDVOTA       NUMBER(08),
  NOPCMAS      NUMBER(08),
  NOPCMEN      NUMBER(08),
  NVOTMAS      NUMBER(08),
  NVOTMEN      NUMBER(08),
  PDIFER       NUMBER(5,2)
);
ALTER TABLE HIS_VMASDIFOPC
  ADD CONSTRAINT HIS_VMASDIF_PK PRIMARY KEY (IDVOTA);

ALTER TABLE HIS_VMASDIFOPC
  ADD CONSTRAINT HISVMAS_VOTAC_FK foreign key (IDVOTA)
      REFERENCES VOTACION (IDVOTA);

----------------------------------- 9
CREATE TABLE HIS_VMENDIFOPC
(
  IDVOTA       NUMBER(08),
  NOPCMAS      NUMBER(08),
  NOPCMEN      NUMBER(08),
  NVOTMAS      NUMBER(08),
  NVOTMEN      NUMBER(08),
  PDIFER       NUMBER(5,2)
);
ALTER TABLE HIS_VMENDIFOPC
  ADD CONSTRAINT HIS_VMENDIF_PK PRIMARY KEY (IDVOTA);

ALTER TABLE HIS_VMENDIFOPC
  ADD CONSTRAINT HISVMEN_VOTAC_FK foreign key (IDVOTA)
      REFERENCES VOTACION (IDVOTA);

----------------------------------- 10
CREATE TABLE HIS_VOTTOPPER
(
  IDPERSON     NUMBER(08),
  NMAXVOT      NUMBER(08)
);
ALTER TABLE HIS_VOTTOPPER
  ADD CONSTRAINT HIS_VTOPPER_PK PRIMARY KEY (IDPERSON);
ALTER TABLE HIS_VOTTOPPER
  ADD CONSTRAINT HIS_VTOPPER_PERSON_FK foreign key (IDPERSON)
      REFERENCES PERSONAS (IDPERSON);    

spool off;