spool 8-tr_ins_votapersona.log
prompt creando trigger tr_ins_votapersona...
CREATE OR REPLACE TRIGGER TR_INS_VOTAPERSONA
 AFTER INSERT ON VOTAPERSONA FOR EACH ROW
-- ******************************************************************************
-- NOMBRE:      TR_INS_VOTAPERSONA
-- PROPSITO:   Este trigger sirve para el mdulo Estadstico.
--              Una persona despus de realizar una votacin, acumula un contador
--              de votaciones que ha realizado
-- ******************************************************************************
DECLARE
   lnumvotos    PERSONAS.NUMVOTOS%TYPE;
   lnmaxvot     HIS_VOTTOPPER.NMAXVOT%TYPE;
BEGIN
   -- Actualiza tabla Estadistica
   -- ------------------------------------------------------------------------
   -- Consulta 10
   -- Votaciones maximas realizadas por una persona HIS_VOTTOPPER
   -- ------------------------------------------------------------------------
   BEGIN
     SELECT numvotos
       INTO lnumvotos
       FROM PERSONAS
      WHERE IDPERSON = :NEW.IDPERSON;
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
            lnumvotos := 0;
   END;
   --
   lnumvotos := NVL(lnumvotos,0) + 1;
   --
   UPDATE PERSONAS SET numvotos = lnumvotos WHERE IDPERSON = :NEW.IDPERSON;
   --
   BEGIN
   	 SELECT NMAXVOT
   	   INTO lnmaxvot
   	   FROM HIS_VOTTOPPER
   	  WHERE rownum = 1;
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
          lnmaxvot := 0;
   END;
   --
   IF lnumvotos > NVL(lnmaxvot,0) THEN
      DELETE HIS_VOTTOPPER;
   END IF;
   --
   IF lnumvotos >= lnmaxvot  THEN
	    INSERT INTO HIS_VOTTOPPER(idperson, nmaxvot)
        VALUES (:NEW.IDPERSON, lnumvotos);
   END IF;
END;
/
spool off;