spool 9-tr_upd_estado_votacion.log
prompt creando trigger tr_upd_estado_votacion...
CREATE OR REPLACE TRIGGER TR_UPD_ESTADO_VOTACION
 AFTER UPDATE ON VOTACION FOR EACH ROW
-- ******************************************************************************
-- NOMBRE:      T_UPD_ESTADO_VOTACION
-- PROPSITO:   Este trigger sirve para el mdulo Estadstico.
--              Despus de cerrar una votacin, se tienen que realizar una serie
--              de calculos.
-- ******************************************************************************
DECLARE
   lnvotapar VOTACION.nvottot%TYPE;
   lpparti   VOTACION.pparti%TYPE;
   lnvotmpar VOTACION.nvottot%TYPE;
   lnopcmax  OPCIONES.nopcio%type;
   lprestmax OPCIONES.prestot%type;
   lnvotmax  OPCIONES.nnumvot%type;
   lnopcmin  OPCIONES.nopcio%type;
   lprestmin OPCIONES.prestot%type;
   lnvotmin  OPCIONES.nnumvot%type;
   ldiferen  OPCIONES.prestot%type;
   lpdif     OPCIONES.prestot%type;
BEGIN
  IF (:NEW.CESTADO = 3 ) THEN
     -- Actualiza tabla Estadisticas
     -- ------------------------------------------------------------------------
     -- Consulta 1
     -- Votaciones finalizadas por PAIS/ANYO
     -- ------------------------------------------------------------------------
     FOR REG IN (SELECT P.CODPAIS
                 FROM PAISES P, VOTACENSO VC
                WHERE VC.IDVOTA = :NEW.idvota
                  AND (P.FBAJA IS NULL OR P.FBAJA > :OLD.FFECINI)
                  AND P.CODPAIS BETWEEN NVL(VC.CODPAIS,'AA') AND NVL(VC.CODPAIS,'ZZ'))
     LOOP
       BEGIN
     	    INSERT INTO VOTFIN_PAISANYO(CODPAIS,NANYO,NVOTAFIN)
     	      VALUES (REG.CODPAIS, TO_NUMBER(TO_CHAR(:OLD.FFECINI,'YYYY')), 1);
       EXCEPTION
         WHEN DUP_VAL_ON_INDEX THEN
            -- Si existe Actualizo
            UPDATE VOTFIN_PAISANYO VP SET VP.NVOTAFIN = VP.NVOTAFIN + 1
             WHERE CODPAIS = REG.CODPAIS
               AND NANYO = (TO_NUMBER(TO_CHAR(:OLD.FFECINI,'YYYY')));
       END;
     END LOOP;
     -- ------------------------------------------------------------------------
     -- Consulta 2 y 3
     -- Votaciones finalizadas VMEDPART_CENSANYO
     -- ------------------------------------------------------------------------
     FOR REG IN (SELECT 0 TIP, null CODPAIS, null IDREGION, null IDLOCALI
                   FROM VOTACENSO VC
                  WHERE  VC.IDVOTA = :NEW.IDVOTA
                UNION ALL
                 SELECT 1 TIP, P.CODPAIS CODPAIS, NULL IDREGION, NULL IDLOCALI
                   FROM VOTACENSO VC, PAISES P
                  WHERE VC.IDVOTA = :NEW.IDVOTA
                    AND P.CODPAIS BETWEEN NVL(VC.CODPAIS,'AA') AND NVL(VC.CODPAIS,'ZZ')
                UNION ALL
                 SELECT 2 TIP, r.codpais, r.idregion, null IDLOCALI
                   FROM VOTACENSO VC, REGION R
                  WHERE VC.IDVOTA = :NEW.IDVOTA
                    AND R.CODPAIS  BETWEEN NVL(VC.CODPAIS,'AA') AND NVL(VC.CODPAIS,'ZZ')
                    AND R.IDREGION BETWEEN NVL(VC.IDREGION,0) AND NVL(VC.IDREGION,99999999)
                UNION ALL
                 SELECT 3 TIP, L.codpais, L.idregion, L.idlocali
                   FROM VOTACENSO VC, LOCALIDAD L
                  WHERE VC.IDVOTA = :NEW.IDVOTA
                    AND l.CODPAIS  BETWEEN NVL(VC.CODPAIS,'AA') AND NVL(VC.CODPAIS,'ZZ')
                    AND l.IDREGION BETWEEN NVL(VC.IDREGION,0) AND NVL(VC.IDREGION,99999999)
                    AND L.IDLOCALI BETWEEN NVL(VC.IDLOCALI,0) AND NVL(VC.IDLOCALI,99999999))
     LOOP
       BEGIN
     	    INSERT INTO VMEDPART_CENSANYO(IDVMEDPAR, TIPCENSO, CODPAIS, IDREGION, IDLOCALI, NANYO, NVOTAFIN, PSUMPARTI, NMEDPPAR)
     	      VALUES (seq_idvmedpar.nextval, REG.TIP, REG.CODPAIS, REG.IDREGION, REG.IDLOCALI,
     	              TO_NUMBER(TO_CHAR(:OLD.FFECINI,'YYYY')), 1, :new.pparti, :new.pparti);
       EXCEPTION
         WHEN DUP_VAL_ON_INDEX THEN
            -- Si existe Actualizo
            UPDATE VMEDPART_CENSANYO VP SET VP.NVOTAFIN = VP.NVOTAFIN + 1,
                                            VP.PSUMPARTI = VP.PSUMPARTI + :NEW.PPARTI,
                                            VP.NMEDPPAR = ROUND((VP.PSUMPARTI + :NEW.PPARTI) / (VP.NVOTAFIN + 1),2)
             WHERE ((reg.tip = 0 and CODPAIS IS NULL AND IDREGION IS NULL AND IDLOCALI IS NULL) OR
                    (reg.tip = 1 and CODPAIS = REG.CODPAIS AND IDREGION IS NULL AND IDLOCALI IS NULL) OR
                    (reg.tip = 2 and CODPAIS = REG.CODPAIS AND IDREGION = REG.IDREGION AND IDLOCALI IS NULL) OR
                    (reg.tip = 3 and CODPAIS = REG.CODPAIS AND IDREGION = REG.IDREGION AND IDLOCALI = REG.IDLOCALI))
               AND NANYO = (TO_NUMBER(TO_CHAR(:OLD.FFECINI,'YYYY')));
       END;
     END LOOP;
     -- ------------------------------------------------------------------------
     -- Consulta 4
     -- Votaciones finalizadas VOTMASPART_ANYO, con ms participacin por ao
     -- ------------------------------------------------------------------------
     BEGIN
       SELECT nvotapar, pparti
         INTO lnvotapar, lpparti
         FROM VOTMASPART_ANYO
        WHERE NANYO = TO_CHAR(:NEW.FFECINI,'YYYY')
          AND rownum = 1;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            lnvotapar:=:NEW.NVOTTOT; lpparti:=:new.pparti;
     END;
     --
     IF :new.pparti >= NVL(lpparti,0) THEN
        IF :new.NVOTTOT > lnvotapar THEN
           DELETE VOTMASPART_ANYO WHERE NANYO = TO_CHAR(:NEW.FFECINI,'YYYY');
        END IF;
     END IF;
     --
     IF :new.pparti >= NVL(lpparti,0)  THEN
  	    INSERT INTO VOTMASPART_ANYO(NANYO,IDVOTA, NVOTAPAR, PPARTI)
         VALUES (TO_CHAR(:NEW.FFECINI,'YYYY'), :NEW.IDVOTA, :NEW.NVOTTOT, :NEW.PPARTI);
     END IF;
     -- ------------------------------------------------------------------------
     -- Consulta 5
     -- Votaciones finalizadas VOTMASP_LOCANY, con ms votos emitidos por ao/localidad
     -- ------------------------------------------------------------------------
     FOR REG IN (   SELECT PC.CODPAIS, PC.IDREGION, PC.IDLOCALI, COUNT(1) NVOTOS
                     FROM VOTAPERSONA VP, PERSOCENSO PC
                    WHERE VP.IDVOTA = :NEW.IDVOTA
                      AND PC.IDPERSON = VP.IDPERSON
                   GROUP BY PC.CODPAIS, PC.IDREGION, PC.IDLOCALI)
     LOOP
       BEGIN
       	 SELECT NVOTMPAR
       	   INTO lnvotmpar
           FROM VOTMASP_LOCANY
       	  WHERE nanyo = TO_CHAR(:NEW.FFECINI,'YYYY')
       	    AND rownum = 1;
       EXCEPTION
         WHEN NO_DATA_FOUND THEN
              lnvotmpar := 0;
       END;
       --
       IF reg.nvotos > lnvotmpar THEN
          DELETE VOTMASP_LOCANY WHERE nanyo = TO_CHAR(:NEW.FFECINI,'YYYY');
       END IF;
       IF reg.nvotos >= lnvotmpar THEN
        	INSERT INTO VOTMASP_LOCANY (NANYO, CODPAIS, IDREGION, IDLOCALI, IDVOTA, NVOTMPAR)
          	VALUES (TO_CHAR(:NEW.FFECINI,'YYYY'), REG.CODPAIS, REG.IDREGION, REG.IDLOCALI, :NEW.IDVOTA, REG.NVOTOS);
       END IF;
     END LOOP;
     -- ------------------------------------------------------------------------
     -- Consulta 7
     -- Votacin historicamente a tenido ms participacin. HIS_VOTMASPARTI
     -- ------------------------------------------------------------------------
     BEGIN
       SELECT NTOTPAR, pparti
         INTO lnvotapar, lpparti
         FROM HIS_VOTMASPARTI
        WHERE rownum = 1;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            lnvotapar:=:NEW.NVOTTOT; lpparti:=:new.pparti;
     END;
     --
     IF :new.pparti >= NVL(lpparti,0) THEN
        IF :new.NVOTTOT > lnvotapar THEN
           DELETE HIS_VOTMASPARTI;
        END IF;
     END IF;
     --
     IF :new.pparti >= NVL(lpparti,0)  THEN
  	    INSERT INTO HIS_VOTMASPARTI(IDVOTA, NTOTPAR, PPARTI)
         VALUES (:NEW.IDVOTA, :NEW.NVOTTOT, :NEW.PPARTI);
     END IF;
     -- ------------------------------------------------------------------------
     -- Consulta 8 y 9
     -- Votacin historicamente a tenido ms/menso diferencia porcentual entre la
     -- opcin ms y menos votada
     -- ------------------------------------------------------------------------
     SELECT nopcio, prestot, nnumvot
       INTO lnopcmax, lprestmax, lnvotmax
       FROM OPCIONES where idvota = :NEW.IDVOTA
        and nnumvot = (SELECT max(nnumvot) from OPCIONES where idvota =:NEW.IDVOTA);
     --
     SELECT nopcio, prestot, nnumvot
       INTO lnopcmin, lprestmin, lnvotmin
       FROM OPCIONES where idvota = :NEW.IDVOTA
        and nnumvot = (SELECT min(nnumvot) from OPCIONES where idvota =:NEW.IDVOTA);
     --
     ldiferen := (lprestmax - lprestmin);
     --
     BEGIN
     	 SELECT PDIFER
     	   INTO lpdif
     	   FROM HIS_VMASDIFOPC
        WHERE ROWNUM = 1;
     EXCEPTION
       WHEN NO_dATA_FOUND THEN
            lpdif := 0;
     END;
     --
     IF ldiferen > lpdif THEN
        DELETE HIS_VMASDIFOPC;
     END IF;
     IF ldiferen >= lpdif THEN
        INSERT INTO HIS_VMASDIFOPC(IDVOTA, NOPCMAS, NOPCMEN, NVOTMAS, NVOTMEN, PDIFER)
         VALUES (:new.idvota, lnopcmax, lnopcmin, lnvotmax, lnvotmin, ldiferen);
     END IF;
     --
     lpdif := 999.99;
     --
     BEGIN
     	 SELECT PDIFER
     	   INTO lpdif
     	   FROM HIS_VMENDIFOPC
        WHERE ROWNUM = 1;
     EXCEPTION
       WHEN NO_dATA_FOUND THEN
            lpdif := 999.99;
     END;
     --
     IF ldiferen < lpdif THEN
        DELETE HIS_VMENDIFOPC;
     END IF;
     --
     IF (ldiferen <= lpdif OR lpdif is null) THEN
        INSERT INTO HIS_VMENDIFOPC(IDVOTA, NOPCMAS, NOPCMEN, NVOTMAS, NVOTMEN, PDIFER)
         VALUES (:new.idvota, lnopcmax, lnopcmin, lnvotmax, lnvotmin, ldiferen);
     END IF;
     --
  END IF;
END;
/
spool off;